// HyperlinkTestView.cpp : implementation of the CHyperlinkTestView class
//

#include "stdafx.h"
#include "HyperlinkTest.h"
#include "HyperlinkTestDoc.h"
#include "Hyperlink.h"
#include "HyperlinkTestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

COLORREF	g_dwColours[9] = {0x00000000, 0x000000FF, 0x00008000, 0x0000FFFF, 
								0x00FF0000, 0x00FF00FF, 0x00FFFF00, 0x00FFFFFF, 
								HL_BACKCOLOUR_TRANSPARENT};
UINT		g_uIDs[9] = {ID_PIC_COLOURS1, ID_PIC_COLOURS2, ID_PIC_COLOURS3, 
							ID_PIC_COLOURS4, ID_PIC_COLOURS5, ID_PIC_COLOURS6, 
							ID_PIC_COLOURS7, ID_PIC_COLOURS8, ID_PIC_COLOURS9};

/////////////////////////////////////////////////////////////////////////////
// CHyperlinkTestView

IMPLEMENT_DYNCREATE(CHyperlinkTestView, CFormView)

BEGIN_MESSAGE_MAP(CHyperlinkTestView, CFormView)
	//{{AFX_MSG_MAP(CHyperlinkTestView)
	ON_BN_CLICKED(ID_BTN_ALLOWMODSTOFONT, OnBtnAllowModsToFont)
	ON_BN_CLICKED(ID_BTN_ARIAL, OnBtnArial)
	ON_BN_CLICKED(ID_BTN_BOLD, OnBtnBold)
	ON_BN_CLICKED(ID_BTN_ITALIC, OnBtnItalic)
	ON_BN_CLICKED(ID_BTN_COMIC, OnBtnComic)
	ON_BN_CLICKED(ID_BTN_NARROW, OnBtnNarrow)
	ON_BN_CLICKED(ID_BTN_SHORT, OnBtnShort)
	ON_BN_CLICKED(ID_BTN_TALL, OnBtnTall)
	ON_BN_CLICKED(ID_BTN_TALLER, OnBtnTaller)
	ON_BN_CLICKED(ID_BTN_TEXT, OnBtnText)
	ON_BN_CLICKED(ID_BTN_WIDE, OnBtnWide)
	ON_BN_CLICKED(ID_BTN_WIDER, OnBtnWider)
	ON_BN_CLICKED(ID_BTN_WRAP, OnBtnWrap)
	ON_CBN_SELCHANGE(ID_CMB_COLOURS, OnSelChangeCmbColours)
	ON_BN_CLICKED(ID_BTN_TIMES, OnBtnTimes)
	ON_EN_CHANGE(ID_TXT_LINK, OnChangeTxtLink)
	ON_EN_CHANGE(ID_TXT_TEXT, OnChangeTxtText)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(ID_BTN_IMAGE, OnBtnImage)
	ON_BN_CLICKED(ID_BTN_ABOVE, OnBtnAbove)
	ON_BN_CLICKED(ID_BTN_BELOW, OnBtnBelow)
	ON_BN_CLICKED(ID_BTN_BOTTOM, OnBtnBottom)
	ON_BN_CLICKED(ID_BTN_CENTRE, OnBtnCentre)
	ON_BN_CLICKED(ID_BTN_LEFT, OnBtnLeft)
	ON_BN_CLICKED(ID_BTN_MIDDLE, OnBtnMiddle)
	ON_BN_CLICKED(ID_BTN_RIGHT, OnBtnRight)
	ON_BN_CLICKED(ID_BTN_TOP, OnBtnTop)
	ON_BN_CLICKED(ID_BTN_TRANSPARENT, OnBtnTransparent)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHyperlinkTestView construction/destruction

CHyperlinkTestView::CHyperlinkTestView()
	: CFormView(CHyperlinkTestView::IDD)
{
	//{{AFX_DATA_INIT(CHyperlinkTestView)
	m_bBold = TRUE;
	m_bCanModify = TRUE;
	m_bItalic = FALSE;
	m_iHeight = 0;
	m_iWidth = 0;
	m_iFontName = 1;
	m_iColour = 0;
	m_bUseText = TRUE;
	m_bWrapText = TRUE;
	m_strText = _T("A Sample Pin");
	m_strLink = _T("");
	m_bUseImage = TRUE;
	m_iPosition = 4;
	m_iAlignment = 1;
	m_bTransparent = FALSE;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CHyperlinkTestView::~CHyperlinkTestView()
{
}

void CHyperlinkTestView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHyperlinkTestView)
	DDX_Control(pDX, ID_PIC_BORDER, m_picBorder);
	DDX_Check(pDX, ID_BTN_BOLD, m_bBold);
	DDX_Check(pDX, ID_BTN_ALLOWMODSTOFONT, m_bCanModify);
	DDX_Check(pDX, ID_BTN_ITALIC, m_bItalic);
	DDX_Radio(pDX, ID_BTN_SHORT, m_iHeight);
	DDX_Radio(pDX, ID_BTN_NARROW, m_iWidth);
	DDX_Radio(pDX, ID_BTN_ARIAL, m_iFontName);
	DDX_CBIndex(pDX, ID_CMB_COLOURS, m_iColour);
	DDX_Check(pDX, ID_BTN_TEXT, m_bUseText);
	DDX_Check(pDX, ID_BTN_WRAP, m_bWrapText);
	DDX_Text(pDX, ID_TXT_TEXT, m_strText);
	DDX_Text(pDX, ID_TXT_LINK, m_strLink);
	DDX_Check(pDX, ID_BTN_IMAGE, m_bUseImage);
	DDX_Radio(pDX, ID_BTN_ABOVE, m_iPosition);
	DDX_Radio(pDX, ID_BTN_LEFT, m_iAlignment);
	DDX_Check(pDX, ID_BTN_TRANSPARENT, m_bTransparent);
	//}}AFX_DATA_MAP
}

BOOL CHyperlinkTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CHyperlinkTestView printing

BOOL CHyperlinkTestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CHyperlinkTestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CHyperlinkTestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CHyperlinkTestView::OnPrint(CDC* pDC, CPrintInfo*)
{
	// TODO: add code to print the controls
}

/////////////////////////////////////////////////////////////////////////////
// CHyperlinkTestView diagnostics

#ifdef _DEBUG
void CHyperlinkTestView::AssertValid() const
{
	CFormView::AssertValid();
}

void CHyperlinkTestView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CHyperlinkTestDoc* CHyperlinkTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHyperlinkTestDoc)));
	return (CHyperlinkTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHyperlinkTestView message handlers

void CHyperlinkTestView::OnInitialUpdate() 
{
	CRect	rctWindow ;

	CFormView::OnInitialUpdate();
	
	m_picBorder.GetClientRect(&rctWindow);
	rctWindow.InflateRect(-1, -1);
	m_picBorder.ClientToScreen(&rctWindow);
	ScreenToClient(&rctWindow);
	m_wndHyperlink.SetBitmapID(ID_BMP_PIN);
	m_wndHyperlink.SetTextColour(0x00FF00FF);
	m_wndHyperlink.SetActiveTextColour(0x0000FFFF);
	m_wndHyperlink.SetTextPosition(HL_TEXTPOS_NONE, HL_TEXTALIGN_CENTRE);
	m_wndHyperlink.AllowModsToFont();
	m_wndHyperlink.SetFontName(_T("Comic Sans MS") );
	m_wndHyperlink.SetFontSize(12, 8);
	m_wndHyperlink.SetFontAttributes(HL_FONTBOLD, HL_FONTNOTITALIC);
	m_wndHyperlink.Create(NULL,"A Sample Pin", WS_CHILD|WS_VISIBLE, rctWindow, this, 
							9999);
}

void CHyperlinkTestView::OnDraw(CDC* pDC) 
{
	CBrush		brColour, *pBrOld ;
	CRect		rctClient ;
	int			n, iIndex ;

	for (n = 0 ; n < 9 ; n++)
	{
		rctClient = GetColourPicRect(g_dwColours[n], iIndex);
		rctClient.InflateRect(-1, -1);
		if (n < 8)
			brColour.CreateSolidBrush(g_dwColours[n]);
		else
			brColour.CreateSolidBrush(0x00C0C0C0);
		pBrOld = (CBrush *)pDC->SelectObject(&brColour);
		if (n < 8)
			pDC->SelectStockObject(NULL_PEN);
		else
			pDC->SelectStockObject(BLACK_PEN);
		pDC->Rectangle(rctClient);
		pDC->SelectObject(pBrOld);
		brColour.DeleteObject();
	}

	OnSelChangeCmbColours();
}

CRect CHyperlinkTestView::GetColourPicRect(COLORREF dwColour, int& iIndex)
{
	CRect	rctClient ;
	CStatic	*pPicture ;
	int		n ;

	iIndex = -1 ;
	if (dwColour == HL_BACKCOLOUR_TRANSPARENT)
		iIndex = 8 ;
	else
	{
		for (n = 0 ; n < 8 ; n++)
		{
			if (g_dwColours[n] == dwColour)
			{
				iIndex = n ;
				break ;
			}
		}
	}

	if (iIndex != -1)
	{
		pPicture = (CStatic *)GetDlgItem(g_uIDs[iIndex]);
		if (pPicture != NULL)
		{
			pPicture->GetClientRect(&rctClient);
			pPicture->ClientToScreen(&rctClient);
			ScreenToClient(&rctClient);
		}
	}

	return rctClient ;
}

void CHyperlinkTestView::OnBtnAllowModsToFont() 
{
	UpdateData(TRUE);

	m_wndHyperlink.AllowModsToFont(m_bCanModify);
}

void CHyperlinkTestView::OnBtnArial() 
{
	m_wndHyperlink.SetFontName(_T("Arial") );
}

void CHyperlinkTestView::OnBtnBold() 
{
	UpdateData(TRUE);
	
	m_wndHyperlink.SetFontAttributes(m_bBold, m_bItalic);
}

void CHyperlinkTestView::OnBtnItalic() 
{
	UpdateData(TRUE);
	
	m_wndHyperlink.SetFontAttributes(m_bBold, m_bItalic);
}

void CHyperlinkTestView::OnBtnComic() 
{
	m_wndHyperlink.SetFontName(_T("Comic Sans MS") );
}

void CHyperlinkTestView::OnBtnNarrow() 
{
	ChangeFontSize();
}

void CHyperlinkTestView::OnBtnShort() 
{
	ChangeFontSize();
}

void CHyperlinkTestView::ChangeFontSize(void)
{
	UINT	uWidth, uHeight ;

	UpdateData(TRUE);

	if (m_iWidth == 0)
		uWidth = 8 ;
	else if (m_iWidth == 1)
		uWidth = 16 ;
	else if (m_iWidth == 2)
		uWidth = 24 ;

	if (m_iHeight == 0)
		uHeight = 12 ;
	else if (m_iHeight == 1)
		uHeight = 18 ;
	else if (m_iHeight == 2)
		uHeight = 24 ;

	m_wndHyperlink.SetFontSize(uHeight, uWidth);
}

void CHyperlinkTestView::OnBtnTall() 
{
	ChangeFontSize();
}

void CHyperlinkTestView::OnBtnTaller() 
{
	ChangeFontSize();
}

void CHyperlinkTestView::OnBtnText() 
{
	UpdateData(TRUE);

	if (m_bUseText)
		m_wndHyperlink.SetWindowText(m_strText);
	else
		m_wndHyperlink.SetWindowText(_T("") );
}

void CHyperlinkTestView::OnBtnWide() 
{
	ChangeFontSize();
}

void CHyperlinkTestView::OnBtnWider() 
{
	ChangeFontSize();
}

void CHyperlinkTestView::OnBtnWrap() 
{
	UpdateData(TRUE);
	
	m_wndHyperlink.SetTextWrapping(m_bWrapText);
}

void CHyperlinkTestView::OnSelChangeCmbColours() 
{
	CClientDC	dc(this);
	COLORREF	dwColour ;
	CPen		penBorder, *pPenOld ;
	CRect		rctColour ;
	int			n, iIndex ;

	UpdateData(TRUE);

	if (m_iColour == 0)
		dwColour = m_wndHyperlink.GetBackColour();
	else if (m_iColour == 1)
		dwColour = m_wndHyperlink.GetTextColour();
	else if (m_iColour == 2)
		dwColour = m_wndHyperlink.GetActiveTextColour();

	dc.SelectStockObject(NULL_BRUSH);
	penBorder.CreatePen(PS_SOLID, 3,(COLORREF)0x00C0C0C0);
	pPenOld = (CPen *)dc.SelectObject(&penBorder);
	for (n = 0 ; n < 9 ; n++)
	{
		rctColour = GetColourPicRect(g_dwColours[n], iIndex);
		if (n == 8)
			rctColour.InflateRect(1, 1);
		dc.Rectangle(rctColour);
	}
	dc.SelectObject(pPenOld);
	penBorder.DeleteObject();

	rctColour = GetColourPicRect(dwColour, iIndex);
	penBorder.CreatePen(PS_SOLID, 3,(COLORREF)0x00000000);
	pPenOld = (CPen *)dc.SelectObject(&penBorder);
	dc.Rectangle(rctColour);
	dc.SelectObject(pPenOld);
	penBorder.DeleteObject();
	UpdateWindow();
}

void CHyperlinkTestView::OnBtnTimes() 
{
	m_wndHyperlink.SetFontName(_T("Times New Roman") );
}

void CHyperlinkTestView::OnChangeTxtLink() 
{
	UpdateData(TRUE);
	
	m_wndHyperlink.SetLinkTarget(m_strLink);
}

void CHyperlinkTestView::OnChangeTxtText() 
{
	UpdateData(TRUE);
	
	if (m_bUseText)
		m_wndHyperlink.SetWindowText(m_strText);
}

void CHyperlinkTestView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRect	rctColour ;
	int		n, iIndex ;

	UpdateData(TRUE);
		
	for (n = 0 ; n < 9 ; n++)
	{
		rctColour = GetColourPicRect(g_dwColours[n], iIndex);
		if (rctColour.PtInRect(point) )
		{
			if (m_iColour == 0)
				m_wndHyperlink.SetBackColour(g_dwColours[n]);
			else if (m_iColour == 1)
				m_wndHyperlink.SetTextColour(g_dwColours[n]);
			else if (m_iColour == 2)
				m_wndHyperlink.SetActiveTextColour(g_dwColours[n]);

			OnSelChangeCmbColours();

			break ;
		}
	}

	CFormView::OnLButtonDown(nFlags, point);
}

void CHyperlinkTestView::OnBtnImage() 
{
	UpdateData(TRUE);

	if (m_bUseImage)
		m_wndHyperlink.SetBitmapID(ID_BMP_PIN);
	else
		m_wndHyperlink.SetBitmapID(0);
}

void CHyperlinkTestView::OnBtnAbove() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::ChangeTextPosition(void)
{
	UINT	uPosition, uAlignment ;

	UpdateData(TRUE);

	if (m_iPosition == 0)
		uPosition = HL_TEXTPOS_ABOVE ;
	else if (m_iPosition == 1)
		uPosition = HL_TEXTPOS_TOP ;
	else if (m_iPosition == 2)
		uPosition = HL_TEXTPOS_MIDDLE ;
	else if (m_iPosition == 3)
		uPosition = HL_TEXTPOS_BOTTOM ;
	else if (m_iPosition == 4)
		uPosition = HL_TEXTPOS_BELOW ;

	if (m_iAlignment == 0)
		uAlignment = HL_TEXTALIGN_LEFT ;
	else if (m_iAlignment == 1)
		uAlignment = HL_TEXTALIGN_CENTRE ;
	else if (m_iAlignment == 2)
		uAlignment = HL_TEXTALIGN_RIGHT ;

	m_wndHyperlink.SetTextPosition(uPosition, uAlignment);
}

void CHyperlinkTestView::OnBtnBelow() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnBottom() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnCentre() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnLeft() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnMiddle() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnRight() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnTop() 
{
	ChangeTextPosition();
}

void CHyperlinkTestView::OnBtnTransparent() 
{
	UpdateData(TRUE);
	
	m_wndHyperlink.SetTransparentBitmap(m_bTransparent);
}
