// HyperlinkTestView.h : interface of the CHyperlinkTestView class
//
/////////////////////////////////////////////////////////////////////////////

class CHyperlinkTestView : public CFormView
{
protected: // create from serialization only
	CHyperlinkTestView();
	DECLARE_DYNCREATE(CHyperlinkTestView)

public:
	//{{AFX_DATA(CHyperlinkTestView)
	enum { IDD = IDD_HYPERLINKTEST_FORM };
	CStatic	m_picBorder;
	BOOL	m_bBold;
	BOOL	m_bCanModify;
	BOOL	m_bItalic;
	int		m_iHeight;
	int		m_iWidth;
	int		m_iFontName;
	int		m_iColour;
	BOOL	m_bUseText;
	BOOL	m_bWrapText;
	CString	m_strText;
	CString	m_strLink;
	BOOL	m_bUseImage;
	int		m_iPosition;
	int		m_iAlignment;
	BOOL	m_bTransparent;
	//}}AFX_DATA

// Attributes
public:
	CHyperlinkTestDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHyperlinkTestView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo*);
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHyperlinkTestView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CHyperlinkTestView)
	afx_msg void OnBtnAllowModsToFont();
	afx_msg void OnBtnArial();
	afx_msg void OnBtnBold();
	afx_msg void OnBtnItalic();
	afx_msg void OnBtnComic();
	afx_msg void OnBtnNarrow();
	afx_msg void OnBtnShort();
	afx_msg void OnBtnTall();
	afx_msg void OnBtnTaller();
	afx_msg void OnBtnText();
	afx_msg void OnBtnWide();
	afx_msg void OnBtnWider();
	afx_msg void OnBtnWrap();
	afx_msg void OnSelChangeCmbColours();
	afx_msg void OnBtnTimes();
	afx_msg void OnChangeTxtLink();
	afx_msg void OnChangeTxtText();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnBtnImage();
	afx_msg void OnBtnAbove();
	afx_msg void OnBtnBelow();
	afx_msg void OnBtnBottom();
	afx_msg void OnBtnCentre();
	afx_msg void OnBtnLeft();
	afx_msg void OnBtnMiddle();
	afx_msg void OnBtnRight();
	afx_msg void OnBtnTop();
	afx_msg void OnBtnTransparent();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void ChangeTextPosition(void);
	void ChangeFontSize(void);
	CRect GetColourPicRect(COLORREF dwColour, int& iIndex);
	CHyperlink m_wndHyperlink;
};

#ifndef _DEBUG  // debug version in HyperlinkTestView.cpp
inline CHyperlinkTestDoc* CHyperlinkTestView::GetDocument()
   { return (CHyperlinkTestDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
